function [DataC,symC] = GPSMerge(DataO, symO, DataN, symN, name, cmp, OffAppend);
% GPSMerge: Merges appended data sets which offset with over lapping data
% [DataC,symC] = GPSMerge(DataO, symO, DataN, symN, name, cmp, OffAppend);

% See if there are overlapping times
comps = ['North ';'East  '; 'Height'];
overlap = 0; offs = []; no = length(DataO(1,:)); nn = length(DataN(1,:));
% Check to see if we allowing offsets on append.
if OffAppend
    for i = 1:no;
        for j = 1:nn
            if abs(DataO(1,i)- DataN(1,j)) < 0.0004 , 
                overlap = 1;
                offs = [offs [DataO(1,i); DataN(2,j)-DataO(2,i); (DataO(3,i)^2+DataN(3,j)^2)]];
                % Offset by about an hour so that edits will not  take out
                % both points
                DataN(1,j) = DataN(1,j) + 0.0001 ; 
            end
        end
    end
end
if overlap
    wgh = 1./offs(3,:);
    wm = offs(2,:)*wgh'/sum(wgh);
    % Compute the RMS difference
    nw = length(wgh);
    if nw > 1
        nrms = sqrt((offs(2,:)-wm).*wgh*(offs(2,:)-wm)'/(nw-1));
        wrms = nrms*sqrt(nw/sum(wgh));
    else wrms = 0; nrms = 1; 
    end
    offset = [0; wm ; 0];
    DataC = [DataO DataN-repmat(offset,1,nn)]; symC = [symO symN];
    fprintf(1,'%s Offset %8.1f +- %6.1f mm %s from %d data. WRMS %6.2f mm, NRMS %6.3f\n', ...
        name, wm, sqrt(1/sum(wgh)), comps(cmp,:), nw, wrms, nrms);
else
    DataC = [DataO DataN]; symC = [symO symN];
end
    
    
