function GPSResize
% GPSResize: Routine called when window resize.
% Set the border widths of the figure shell

% Getsize of figure
hf = gcf ;
fullpos = get(gcf,'Position');
%
% Compute the Figure size we want
figsize = [fullpos(3) fullpos(4)];

% Set the border widths of the figure shell
bdwidth = figsize(2)*0.02;
%topbdwidth = figsize(2)*0.05;
% Set the size of the axis and the space in brtween
axisspace = figsize(2)*0.05;
axiswt = figsize(1)*0.68;
axisht = figsize(2)*0.25;

% Compute and set the position and size axis 1 (N component) 
pos = [bdwidth + figsize(1)*0.28,... 
       bdwidth + axisspace*3 + (axisht)*2,...
       axiswt, axisht];
h1 = findobj(hf,'Tag','Axis1');
set(h1,'Position',pos);
% Compute and set the position and size axis 2 (E component) 
pos = [bdwidth + figsize(1)*0.28,... 
       bdwidth + axisspace*2  + axisht,...
       axiswt, axisht];
h2 = findobj(hf,'Tag','Axis2');
set(h2,'Position',pos);
% Compute and set the position and size axis 3 (U component) 
pos = [bdwidth + figsize(1)*0.28,... 
       bdwidth + axisspace,...
       axiswt, axisht];
h3 = findobj(hf,'Tag','Axis3');
set(h3,'Position',pos);

% Dir entry box 
pos = [ bdwidth*2, figsize(2)-2*bdwidth, 80 bdwidth*1.5];
hd = findobj(hf,'Tag','DirLabel');
set(hd,'Position',pos);

pos = [ bdwidth*2+80, figsize(2)-2*bdwidth, figsize(1)*0.2 bdwidth*1.5];
hd = findobj(hf,'Tag','DirName');
set(hd,'Position',pos);

% Compute and set the position and size of the site list box 
pos = [bdwidth*2,... 
       axisht*1.35,...
       figsize(1)*0.1, figsize(2)-axisht*1.35-2*bdwidth];
hs = findobj(hf,'Tag','ListboxSites');
set(hs,'Position',pos);
lbtop = axisht + figsize(2)-axisht-2*bdwidth;
lbbot = axisht*1.35;

% Compute and set the position and size of the gui buttons
buttony = figsize(2)*0.041; 
buttonx = figsize(1)*0.09;
buttonxpos = pos(1) + pos(3) + bdwidth;
buttonypos = lbtop - buttony; 
%buttonspace = figsize(2)*0.004;
% Use some short names
byp = buttonypos;
bys = figsize(2)/38; byh = bys*1.0;

% Load button
pos = [buttonxpos, byp, buttonx, byh];
hl = findobj(hf,'Tag','Pushbutton1');
set(hl,'Position',pos);

% Append button
pos = [buttonxpos, byp - bys, buttonx, byh];
ha = findobj(hf,'Tag','Pushbutton2');
set(ha,'Position',pos);
pos = [buttonxpos+buttonx+3, byp - bys, 28, 15];
ha = findobj(hf,'Tag','OffApp');
set(ha,'Position',pos);

%  MOD TAH 060125: Added difference button
pos = [buttonxpos, byp-2*bys, buttonx,byh];
ha = findobj(hf,'Tag','Difference');
set(ha,'Position',pos);

% Detrend button
byp = byp - bys;
pos = [buttonxpos, byp-2*bys, buttonx,byh];
hd = findobj(hf,'Tag','Pushbutton3');
set(hd,'Position',pos);

% Edit Button
pos = [buttonxpos, byp-3*bys, buttonx,byh];
he = findobj(hf,'Tag','Pushbutton4');
set(he,'Position',pos);

% Block Edit button
pos = [buttonxpos, byp-4*bys, buttonx,byh];
hb = findobj(hf,'Tag','Pushbutton6');
set(hb,'Position',pos);
      
% Break button
pos = [buttonxpos, byp-5*bys, buttonx,byh];
hj = findobj(hf,'Tag','Pushbutton5');
set(hj,'Position',pos);

% Exponent button
pos = [buttonxpos, byp-6*bys, buttonx,byh];
hj = findobj(hf,'Tag','ExponentButton');
set(hj,'Position',pos);

% Logarithmic fit button
pos = [buttonxpos, byp-7*bys, buttonx,byh];
hj = findobj(hf,'Tag','LogButton');
set(hj,'Position',pos);

% EditBreak button
pos = [buttonxpos, byp-8*bys, buttonx,byh];
hj = findobj(hf,'Tag','EditBreak');
set(hj,'Position',pos);

% Zoom button
pos = [buttonxpos, byp-9*bys, buttonx,byh];
hz = findobj(hf,'Tag','ZoomButton');
set(hz,'Position',pos);

% Span button
pos = [buttonxpos, byp-10*bys, buttonx,byh];
hl = findobj(hf,'Tag','Pushbutton7');
set(hl,'Position',pos);

% Save button
pos = [buttonxpos, byp-11*bys, buttonx,byh];
hl = findobj(hf,'Tag','Pushbutton8');
set(hl,'Position',pos);

% Maximum size of outliers button
pos = [buttonxpos, byp-12.4*bys, buttonx,byh];
hl = findobj(hf,'Tag','Text1');
set(hl,'Position',pos);

% Button selector
pos = [buttonxpos, byp-13*bys, buttonx,byh];
hl = findobj(hf,'Tag','Outlier');
set(hl,'Position',pos);

% Maximum sigma text box
pos = [buttonxpos, byp-14.4*bys, buttonx,byh];
hl = findobj(hf,'Tag','Text2');
set(hl,'Position',pos);
pos = [buttonxpos, byp-15*bys, buttonx,byh];
hl = findobj(hf,'Tag','SigmaCut');
set(hl,'Position',pos);
   
% Retain breaks button 
pos = [buttonxpos, byp-16*bys, buttonx,byh];
hl = findobj(hf,'Tag','RetainBreaks');
set(hl,'Position',pos);

% Add break on append
pos = [buttonxpos, byp-17*bys, buttonx,byh];
hl = findobj(hf,'Tag','AppendBreaks');
set(hl,'Position',pos);

% Report Edits to MATLAB Main window
pos = [buttonxpos, byp-18*bys, buttonx,byh];
hl = findobj(hf,'Tag','ReportEdits');
set(hl,'Position',pos);

% Boxes to edit the breaks
pos = [buttonxpos, byp-19.4*bys, buttonx,byh];
hl = findobj(hf,'Tag','BreakList');
set(hl,'Position',pos);

% Button selector
pos = [buttonxpos, byp-20*bys, buttonx,byh];
hl = findobj(hf,'Tag','DeleteBreak');
set(hl,'Position',pos);

% Paremeter set buttons
pos = [buttonxpos, byp-21.4*bys, buttonx,byh];
hz = findobj(hf,'Tag','ParamSet');
set(hz,'Position',pos);
% MOD 090206: Rescaled to add 2 new buttons
byppn = byp-22*bys;byhp = byh*0.9; 
hz = findobj(hf,'Tag','LORes');
set(hz,'Position',[buttonxpos, byppn, buttonx,byh]);
hz = findobj(hf,'Tag','NoEQOff');
set(hz,'Position',[buttonxpos, byppn-1*bys*0.7, buttonx,byhp]);
hz = findobj(hf,'Tag','Annual');
set(hz,'Position',[buttonxpos, byppn-2*bys*0.7, buttonx,byhp]);
hz = findobj(hf,'Tag','Semiannual');
set(hz,'Position',[buttonxpos, byppn-3*bys*0.7, buttonx,byhp]);
hz = findobj(hf,'Tag','ExpRates');
set(hz,'Position',[buttonxpos, byppn-4*bys*0.7, buttonx,byhp]);
hz = findobj(hf,'Tag','RealSigma');
set(hz,'Position',[buttonxpos, byppn-5*bys*0.7, buttonx,byhp]);
hz = findobj(hf,'Tag','DisplayFit');
set(hz,'Position',[buttonxpos, byppn-6*bys*0.7, buttonx,byhp]);
hz = findobj(hf,'Tag','PVOTS');
set(hz,'Position',[buttonxpos, byppn-7*bys*0.7, buttonx,byhp]);
% End of re-scaled aread
hz = findobj(hf,'Tag','Average');
set(hz,'Position',[buttonxpos, byp-28*bys, buttonx,byh]);
hz = findobj(hf,'Tag','AvgLength');
set(hz,'Position',[buttonxpos, byp-29*bys, buttonx,byh]);
% Add option to hide error bars
hz = findobj(hf,'Tag','HideErrb');
set(hz,'Position',[buttonxpos, byp-30*bys, buttonx,byh]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% New options for file names
%
% Name of the edit file.
buttonn = buttony*0.95;
pos = [bdwidth*2+2, lbbot - buttonn, figsize(1)*0.1, buttonn*.75];
hl = findobj(hf,'Tag','EdFileHead');
set(hl,'Position',pos);
pos = [bdwidth*2+4, pos(2)-15 , figsize(1)*0.1, 22];
hl = findobj(hf,'Tag','EditFile');
set(hl,'Position',pos);
hl = findobj(hf,'Tag','EdFileWrite') ;
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.5 28 15])
hl = findobj(hf,'Tag','EdFileErase') ;
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.1 28 15])

% Name of the output ensum summary file.
pos = [bdwidth*2+2,lbbot - 2.5*buttonn, figsize(1)*0.1, buttonn*.75];
hl = findobj(hf,'Tag','EnFileHead');
set(hl,'Position',pos);
pos = [bdwidth*2+4, pos(2)-15 , figsize(1)*0.1, 22];
hl = findobj(hf,'Tag','ENSFile');
set(hl,'Position',pos);
hl = findobj(hf,'Tag','EnFileWrite');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.5 28 15])
hl = findobj(hf,'Tag','EnFileErase');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.1 28 15])

% Name of the root to the detailed outpiut file.
pos = [bdwidth*2+2,lbbot - 4.0*buttonn, figsize(1)*0.1, buttonn*.75];
hl = findobj(hf,'Tag','RtFileHead');
set(hl,'Position',pos);
pos = [bdwidth*2+4, pos(2)-15 , figsize(1)*0.1, 22];
hl = findobj(hf,'Tag','RtFile');
set(hl,'Position',pos);
hl = findobj(hf,'Tag','RtFileWrite');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.5 28 15])
hl = findobj(hf,'Tag','RtFileErase');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.1 28 15])

pos = [bdwidth*2+2,lbbot - 5.5*buttonn, figsize(1)*0.1, buttonn*.75];
hl = findobj(hf,'Tag','SrFileHead');
set(hl,'Position',pos);
pos = [bdwidth*2+4, pos(2)-15 , figsize(1)*0.1, 22];
hl = findobj(hf,'Tag','SrFile');
set(hl,'Position',pos);
hl = findobj(hf,'Tag','SrNormal');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*1.0 28 15])
hl = findobj(hf,'Tag','SrSortAlph');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.6 28 15])
hl = findobj(hf,'Tag','SrSortHorz');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*0.2 28 15])
hl = findobj(hf,'Tag','SrSortVert');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*(-0.2) 28 15])
hl = findobj(hf,'Tag','SrSortWorst');
set(hl,'Position',[pos(1)-bdwidth*2 pos(2)+buttonn*(-0.6) 28 15])

% EQ file name
pos = [bdwidth*2+2,lbbot - 7.0*buttonn, figsize(1)*0.1, buttonn*.75];
hl = findobj(hf,'Tag','EqFileHead');
set(hl,'Position',pos);
pos = [bdwidth*2+4, pos(2)-15 , figsize(1)*0.1, 22];
hl = findobj(hf,'Tag','EqFile');
set(hl,'Position',pos);
hl = findobj(hf,'Tag','ClrEqList');
set(hl,'Position',[pos(1)+figsize(1)*0.1, pos(2)+2 28 15]);
hl = findobj(hf,'Tag','LoadEqList');
set(hl,'Position',[pos(1)+figsize(1)*0.1, pos(2)+2+15 28 15]);

% Print BOX
pos = [bdwidth+5,5 , 65, buttonn*.75];
hl = findobj(hf,'Tag','PrintSetup');
set(hl,'Position',pos);
pos = [bdwidth+70, 5 , 35, buttonn*.75];
hl = findobj(hf,'Tag','PrintButton');
set(hl,'Position',pos);
pos = [bdwidth+105, 5 , 200, buttonn*.75];
hl = findobj(hf,'Tag','PrinfOpt');
set(hl,'Position',pos);


