function p = GenPar(t,mT, np, anpar,sapar,exprt,breaks)
% p = GenPar(t,mT,anpar,sapar,exprt,breaks): Generates one row of
% partials

% Start counting parameters
p = zeros(1,np);
p(1) = 1; p(2) = t-mT;
nc = 2 ;    % Offset and Rate

if anpar, 
    p(nc+1) = cos(2*pi*rem(t,1));
    p(nc+2) = sin(2*pi*rem(t,1));
    nc = nc + 2 ; 
end   % Annual
if sapar, 
    p(nc+1) = cos(4*pi*rem(t,1));
    p(nc+2) = sin(4*pi*rem(t,1));
    nc = nc + 2 ; 
end   % Semi-Annual
%
% Now add up breaks and exponents
nb = 0;
if ~isempty(breaks) 
    nb = length(breaks(:,1));
    for i = 1:nb
        if breaks(i,2) == 0 % Remove condition on < 1 day | abs(breaks(i,2)-breaks(i,1)) < 0.002   % Either zero or < 1day
            if t > breaks(i,1)
                p(nc+1) = 1;
            end
            nc = nc + 1;
        else   %   This is an exponent, see if new rate needed as well
            if t > breaks(i,1) 
                if breaks(i,2) > breaks(i,1)
                    p(nc+1) = 1;
                    p(nc+2) = 1-exp(-(t-breaks(i,1))/abs(breaks(i,2)-breaks(i,1)));
                else
                    p(nc+1) = 1;
                    p(nc+2) = log(1+(t-breaks(i,1))/abs(breaks(i,2))); % Second argument sets start time
                    
                end
            end
            nc = nc + 2;
            if exprt 
                if t > breaks(i,1)
                    p(nc+1) = t-breaks(i,1);
                end
                nc = nc + 1;
            end
        end
    end
end
