function sites = GetSites(udir)
% sites = GetSites(udir): Gets the list of sites from the directory udir
% Generate the list of sites that are needed.
% NOD TAH 060113: Changed to look for mb_ and .pos (pbo time series) files.
% First look for mb_ files
if isempty(udir) 
    form = 'mb_*';
else
    form = strcat(udir,'/mb_*');
end
% OK, See which sites we have as mb_files
d = dir(form) ;
%
% Get the names of all files in the directory
dnames = {d.name};
% get all file names with mb_ in the first three characters
dnames = dnames(strncmp(dnames,'mb_',3));
% Now sort the names

% Reduce the names further by getting only the site names
j = 0 ; sites = [];
for i = 1:length(dnames)
	tname = cell2struct(dnames(i),'name');
	if findstr(tname.name,'.dat1')
		j = j + 1;
		st = tname.name;
		sites = [sites;st(4:11)];
	end
end

% If no mb_ files were found, search for .pos files.
% MOD TAH 090330: changed from frame.pos to .pos to allow different frame
% names to be used (snf10 igs05 etc).
if isempty(sites) 
    if isempty(udir) 
        form = '*.pos';
    else
        form = strcat(udir,'/*.pos');
    end

%   OK, See which sites we have as mb_files
    d = dir(form) ;
%   
%   Get the names of all files in the directory
    dnames = {d.name};

%   Reduce the names further by getting only the site name and solution type
    j = 0 ; sites = [];
    for i = 1:length(dnames)
    	tname = cell2struct(dnames(i),'name');
        j = j + 1;
    	st = tname.name;
        sites = [sites;st(1:20)];
    end
end

