function [DataN, DataE, DataU, Stot, fid, message] = ReadPBOts(fname)
% ReadPBOts: Function to return PBO time series values
%
fid = fopen(fname,'r');
if ( fid == -1 ) 
   message = sprintf('Error: %s not found\n',inp_pos);
   return
end
message = '';

pbo_dot = textread(fname,'%*s %*s %s',1,'headerlines',2);
sta_name = textread(fname,'%*s %*s %*s %s',1,'headerlines',3);
first_epoch = textread(fname,'%*s %*s %*s %d',1,'headerlines',4);
% NEU Reference position :    59.3585312550  206.5391994203  487.21908
[Stot(1) Stot(2) Stot(3)] = textread(fname,'%*s %*s %*s %*s %f %f %f',1,'headerlines',8);
[jday,n,e,u,err_n,err_e,err_u] = textread(fname,'%*d %*d %f %*f %*f %*f %*f %*f %*f %*f %*f %*f %*f %*f %*f %f %f %f %f %f %f %*f %*f %*f%*s','headerlines',9);

% Conert jday back to DecYrs.  First convert MJD to MATLAB's serial date
% number
jday = jday + 678942;
% Now covert.  Needs to be done one at a time due to leap years
for i = 1:length(jday);
    bdfull = datevecl(jday(i));
    decyr = DateToYr(bdfull,6);
    jday(i) = decyr;
end
% Now creat the DataN, DataE, DataU arrays
DataN = [jday'; n'*1000; err_n'*1000];
DataE = [jday'; e'*1000; err_e'*1000];
DataU = [jday'; u'*1000; err_u'*1000];

