function sortsites = SortEns(sort_opt, ensrms, ensnames, sites)
% SortEns: Based on sort option merges and sorts list of sites
%
% Loop over the sites ensnames and link them to RMS for the sites
% Small inconsistency in site name arrays: sites is Nx8 and ensnames is
% 8xN
if sort_opt ~= 'A'
    nx = size(ensnames); numens = nx(1);
    nx = size(sites);    numsite = nx(1);

    locrms = zeros(1,numsite); 
    for i = 1:numsite
        % See if we can find this site in the ensum names
        for j = 1:numens
            if sites(i,1:4) == ensnames(j,1:4) 
               % site names match at first four characters.  If we already
               % have an RMS for site, chose the larger one.
               if sort_opt == 'H', rmssave = ensrms(j,1); 
               elseif sort_opt == 'V', rmssave = ensrms(j,2);
               else rmssave = ensrms(j,3); end
               locrms(i) = max(locrms(i),rmssave);
            end
        end
    end
    [srms,ind] = sort(-locrms);
    sortsites = sites(ind,:);
else    % Alphabetical sort (aviod cellstruct sort which has problems with executable version
    dum = sites(:,1)*128*128*128+sites(:,2)*128*128+sites(:,4)*128+sites(:,4);
    [x,ind] = sort(dum);
    sortsites = sites(ind,:);
end
                