function unbrk = checkbr(breaks)
% CHECKBR Check for duplicate times with breaks
%
unbrk = [];
if ~isempty(breaks)
    nb = length(breaks(:,1));
    ed = ones(1,nb);
    for i = 1:nb-1
        for j = i+1:nb
            if breaks(j,1) == breaks(i,1) && breaks(j,2) == breaks(i,2)
                % If one of these is stanard break remove that one
                if ed(j) == 1 
                    ed(j) = 0; 
                    if breaks(j,2) == 0 && breaks(j,6) == 0
                        fprintf(1,' Removing duplicate regular break %d Date %4d %2d %2d\n',j,YrToDate(breaks(j,1),3))
                    elseif  breaks(j,2) == 0 && breaks(j,6) == 3
                        fprintf(1,' Removing duplicate earthquake break %d Date %4d %2d %2d\n',j,YrToDate(breaks(j,1),3))
                    elseif breaks(j,2) > breaks(j,1)
                        fprintf(1,' Removing duplicate exponent break %d Date %4d %2d %2d tau %f6.2 days \n', ...
                            j,YrToDate(breaks(j,1),3),(breaks(j,2)-breaks(j,2))*365 )
                    else
                        fprintf(1,' Removing duplicate log break %d Date %4d %2d %2d tau %6.2f days \n', ...
                            j,YrToDate(breaks(j,1),3),breaks(j,2)*365 )
                    end
                end
            end
        end
    end
    ed = logical(ed);
    unbrk = breaks(ed,:);
end
