function arrowstr = GenArrowStr(n)
% GenArrowStr: Generates arrow structure based on primary, secondday or
% ensum type velocities

% Based on number assign values for line width, color and error ellipse
% color
if n == 0  % Values for arrow showing scale
    widh   = 1;    % Points wide horizontal
    widv   = 2;    % Points wide vertical 
    colh   = [0 0 0];  % Red lines for horizontal vectors
    colvu  = [.4 .4 .4];  % Dark yellow for Vertical
    colvd  = [.4 .4 .4];  % Dark yellow for Vertical
    errch  = [1 1 1];  % Error ellipise color
    errcv  = [1 1 1];  % Error bar color
elseif n == 1  % Primary vector
    widh   = 1;    % Points wide horizontal
    widv   = 2;    % Points wide vertical 
    colh   = [0 0 1];  % Red lines for horizontal vectors
    colvu  = [220  70  50]/255.;  % Dark yellow for Vertical
    colvd  = [ 50 207 200]/255.;  % Dark yellow for Vertical
    % errch  = [0.8 1 0.6];  % Error ellipise color
    errch  = [0.8 0.8 0.9];  % Error ellipise color
    errcv  = [0 0 .2] ;     % Error bar color
elseif n == 2
    widh   = 1.0;    % Points wide horizontal
    widv   = 2.0;    % Points wide vertical 
    colh   = [0.5 0.0 0];  % Red lines for horizontal vectors
    colvu  = [255 255   0]/255.;  % Dark yellow for Vertical
    colvd  = [128 255 128]/255.;  % Dark yellow for Vertical
    errch  = [0.95 0.80 0.80];  % Error ellipise color
    errcv  = [0.5 0.3 0.3];      % Error bar color
 elseif n == 3
    widh   = 0.5;    % Points wide horizontal
    widv   = 2.0;    % Points wide vertical 
    colh   = [0 1 0];  % Red lines for horizontal vectors
    colvu  = [  0   0 143]/255;  % Dark yellow for Vertical
    colvd  = [128   0   0]/255;  % Dark yellow for Vertical
    errch  = [0.0 0.8 0.9];  % Error ellipise color
    errcv  = [0 0 0];      % Erro bar color
end

% Get the size of arrow requested
ha = findobj(gcf,'Tag','ArhHLimit');
arrhead = get(ha,'Value');

% Make the structure
arrowstr = struct('Widh',widh,'Widv',widv, ...
    'Colh',colh,'Colvu',colvu, 'Colvd',colvd, ...
    'Errch',errch,'Errcv',errcv, 'ArrHead', arrhead);
       