function [lx,ly] = VelToPlot(vels, scale, arrowstr, velinf)
% VelToPlot: Returns lat/long coordinates arrow for velocity vector.
% Vels is 12 element array with long, lat, Ve Vn dVe dVn sVe SVn ...
if arrowstr.ArrHead == 1
    lx = [vels(1) vels(1)+vels(3)*scale(1)];
    ly = [vels(2) vels(2)+vels(4)*scale(2)];
else % Need to generate with a head
    [dn, de] = GenArrowHead(arrowstr.ArrHead); 
    arrowh = velinf.ArrowH; de = de/arrowh; dn/arrowh;
    
    % First generate the arrow in horizontal position and then rotate
    lx = []; ly = [];
    for i = 1:length(vels(1))
        len = sqrt(vels(3,i)^2+vels(4,i)^2+0.0001);
        arh = [0 0 -de 0 de 0 ; 0 len len-dn len-dn/2 len-dn len];
        R = [vels(4,i)/len vels(3,i)/len; -vels(3,i)/len vels(4,i)/len];
        arr = R*arh;
        lx = [lx; vels(1,i)+arr(1,:)*scale(1)];
        ly = [ly; vels(2,i)+arr(2,:)*scale(2)];
    end
end

    
    
