function [TS, sig] = Wmod(t, Est, Cov, varargin)
% [TS, sig] = Wmod(t, Est, Cov, varargin)
% Given model parameters generates a time series with error bars at times t

if nargin == 3,  part{1} = '1'; np = 1;  % Assume just a mean wanted (same as '1' for forth argument
else
    np = 0;
    for i = 1:nargin-3
        if ~isempty(varargin{i})
            np = np + 1;
            % For the simple x function just use straight function which
            % will run in the executable version
            if char(varargin{i}) == '1', part{i} = '1';
            elseif char(varargin{i}) == 'x', part{np} = 'x';
            elseif strncmp('SS',char(varargin{i}),2), part{np} = SSparse(char(varargin{i}));
            else part{np} = inline(char(varargin{i}));
            end
        end
    end
end
%
% Setup the partials array
nd = length(t);
A = [];
for i = 1:nd
    at = [];
    for j = 1:np
        if char(part{j}) == '1', at = [at, 1]; 
        elseif char(part{j}) == 'x', at = [at, t(i)];
        elseif strncmp('SS', char(part{j}),2)
            at = [at, SSeval(char(part{j}),t(i))];
        else at = [at, feval(part{j},t(i))];
        end
    end
    A = [A; at];
end
%
TS = A*Est;
ACv = A*Cov;
for i = 1:nd
    sig(i) = sqrt(ACv(i,:)*A(i,:)');
end
